test-lib.sh 17.5 KB
Newer Older
1 2 3 4
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano
#
5 6 7 8 9 10 11 12 13 14 15 16
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/ .
17

18 19 20
# Keep the original TERM for say_color
ORIGINAL_TERM=$TERM

21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37
# Test the binaries we have just built.  The tests are kept in
# t/ subdirectory and are run in 'trash directory' subdirectory.
if test -z "$TEST_DIRECTORY"
then
	# We allow tests to override this, in case they want to run tests
	# outside of t/, e.g. for running tests on the test library
	# itself.
	TEST_DIRECTORY=$(pwd)
fi
if test -z "$TEST_OUTPUT_DIRECTORY"
then
	# Similarly, override this to store the test-results subdir
	# elsewhere
	TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
fi
GIT_BUILD_DIR="$TEST_DIRECTORY"/..

38 39 40 41 42 43 44 45 46
################################################################
# It appears that people try to run tests without building...
"$GIT_BUILD_DIR/git" >/dev/null
if test $? != 1
then
	echo >&2 'error: you do not seem to have built git yet.'
	exit 1
fi

47 48 49
. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
export PERL_PATH SHELL_PATH

50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65
# if --tee was passed, write the output not only to the terminal, but
# additionally to the file test-results/$BASENAME.out, too.
case "$GIT_TEST_TEE_STARTED, $* " in
done,*)
	# do not redirect again
	;;
*' --tee '*|*' --va'*)
	mkdir -p test-results
	BASE=test-results/$(basename "$0" .sh)
	(GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
	 echo $? > $BASE.exit) | tee $BASE.out
	test "$(cat $BASE.exit)" = 0
	exit
	;;
esac

66 67
# For repeatability, reset the environment to known value.
LANG=C
68
LC_ALL=C
69
PAGER=cat
70
TZ=UTC
71 72
TERM=dumb
export LANG LC_ALL PAGER TERM TZ
73
EDITOR=:
74 75 76 77
# A call to "unset" with no arguments causes at least Solaris 10
# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
# deriving from the command substitution clustered with the other
# ones.
78
unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
79
	my @env = keys %ENV;
80 81 82 83 84 85 86 87
	my $ok = join("|", qw(
		TRACE
		DEBUG
		USE_LOOKUP
		TEST
		.*_TEST
		PROVE
		VALGRIND
88
		UNZIP
89
		PERF_
90 91
	));
	my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92 93
	print join("\n", @vars);
')
J
Jeff King 已提交
94
unset XDG_CONFIG_HOME
95 96 97 98
GIT_AUTHOR_EMAIL=author@example.com
GIT_AUTHOR_NAME='A U Thor'
GIT_COMMITTER_EMAIL=committer@example.com
GIT_COMMITTER_NAME='C O Mitter'
99
GIT_MERGE_VERBOSITY=5
100 101
GIT_MERGE_AUTOEDIT=no
export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
102 103
export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
104
export EDITOR
105

106 107
# Add libc MALLOC and MALLOC_PERTURB test
# only if we are not executing the test with valgrind
J
Junio C Hamano 已提交
108
if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
109
   test -n "$TEST_NO_MALLOC_CHECK"
J
Junio C Hamano 已提交
110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125
then
	setup_malloc_check () {
		: nothing
	}
	teardown_malloc_check () {
		: nothing
	}
else
	setup_malloc_check () {
		MALLOC_CHECK_=3	MALLOC_PERTURB_=165
		export MALLOC_CHECK_ MALLOC_PERTURB_
	}
	teardown_malloc_check () {
		unset MALLOC_CHECK_ MALLOC_PERTURB_
	}
fi
126

127 128 129 130
# Protect ourselves from common misconfiguration to export
# CDPATH into the environment
unset CDPATH

B
Bert Wesarg 已提交
131
unset GREP_OPTIONS
132
unset UNZIP
B
Bert Wesarg 已提交
133

134
case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
135 136 137 138 139 140
1|2|true)
	echo "* warning: Some tests will not work if GIT_TRACE" \
		"is set as to trace on STDERR ! *"
	echo "* warning: Please set GIT_TRACE to something" \
		"other than 1, 2 or true ! *"
	;;
141 142
esac

143 144 145 146 147 148
# Convenience
#
# A regexp to match 5 and 40 hexdigits
_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"

J
Junio C Hamano 已提交
149 150 151
# Zero SHA-1
_z40=0000000000000000000000000000000000000000

152 153 154 155
# Line feed
LF='
'

156 157
export _x05 _x40 _z40 LF

158 159 160 161 162 163
# Each test should start with something like this, after copyright notices:
#
# test_description='Description of this test...
# This test checks if command xyzzy does the right thing...
# '
# . ./test-lib.sh
164 165 166 167 168 169 170 171
[ "x$ORIGINAL_TERM" != "xdumb" ] && (
		TERM=$ORIGINAL_TERM &&
		export TERM &&
		[ -t 1 ] &&
		tput bold >/dev/null 2>&1 &&
		tput setaf 1 >/dev/null 2>&1 &&
		tput sgr0 >/dev/null 2>&1
	) &&
172
	color=t
173 174 175 176 177 178

while test "$#" -ne 0
do
	case "$1" in
	-d|--d|--de|--deb|--debu|--debug)
		debug=t; shift ;;
J
Junio C Hamano 已提交
179 180
	-i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
		immediate=t; shift ;;
181
	-l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
J
Junio C Hamano 已提交
182
		GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
183
	-h|--h|--he|--hel|--help)
184
		help=t; shift ;;
185 186
	-v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
		verbose=t; shift ;;
187
	-q|--q|--qu|--qui|--quie|--quiet)
188 189 190
		# Ignore --quiet under a TAP::Harness. Saying how many tests
		# passed without the ok/not ok details is always an error.
		test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
191 192
	--with-dashes)
		with_dashes=t; shift ;;
193
	--no-color)
194
		color=; shift ;;
195
	--va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
196 197 198 199 200
		valgrind=memcheck
		shift ;;
	--valgrind=*)
		valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
		shift ;;
201 202
	--tee)
		shift ;; # was handled already
203 204 205
	--root=*)
		root=$(expr "z$1" : 'z[^=]*=\(.*\)')
		shift ;;
206
	*)
207
		echo "error: unknown test option '$1'" >&2; exit 1 ;;
208 209 210
	esac
done

211 212
test -n "$valgrind" && verbose=t

213 214
if test -n "$color"
then
215
	say_color () {
216 217 218
		(
		TERM=$ORIGINAL_TERM
		export TERM
219
		case "$1" in
220 221 222
		error)
			tput bold; tput setaf 1;; # bold red
		skip)
A
Adam Spiers 已提交
223
			tput setaf 4;; # blue
224 225
		warn)
			tput setaf 3;; # brown/yellow
226
		pass)
227
			tput setaf 2;; # green
228
		info)
229
			tput setaf 6;; # cyan
230 231
		*)
			test -n "$quiet" && return;;
232 233
		esac
		shift
234
		printf "%s" "$*"
235
		tput sgr0
236
		echo
237
		)
238 239 240
	}
else
	say_color() {
241
		test -z "$1" && test -n "$quiet" && return
242
		shift
243
		printf "%s\n" "$*"
244 245 246 247 248
	}
fi

error () {
	say_color error "error: $*"
249
	GIT_EXIT_OK=t
250 251 252 253 254 255 256
	exit 1
}

say () {
	say_color info "$*"
}

257 258 259 260 261 262 263 264 265
test "${test_description}" != "" ||
error "Test script did not set test_description."

if test "$help" = "t"
then
	echo "$test_description"
	exit 0
fi

266
exec 5>&1
J
Jeff King 已提交
267
exec 6<&0
268 269 270 271 272 273 274 275 276
if test "$verbose" = "t"
then
	exec 4>&2 3>&1
else
	exec 4>/dev/null 3>/dev/null
fi

test_failure=0
test_count=0
J
Junio C Hamano 已提交
277 278
test_fixed=0
test_broken=0
279
test_success=0
280

281 282
test_external_has_tap=0

283
die () {
284 285 286 287 288 289 290 291
	code=$?
	if test -n "$GIT_EXIT_OK"
	then
		exit $code
	else
		echo >&5 "FATAL: Unexpected exit with code $code"
		exit 1
	fi
292 293
}

294
GIT_EXIT_OK=
295
trap 'die' EXIT
296

297 298
# The user-facing functions are loaded from a separate file so that
# test_perf subshells can have them too
299
. "$TEST_DIRECTORY/test-lib-functions.sh"
300

J
Junio C Hamano 已提交
301 302 303 304
# You are not expected to call test_ok_ and test_failure_ directly, use
# the text_expect_* functions instead.

test_ok_ () {
305
	test_success=$(($test_success + 1))
306
	say_color "" "ok $test_count - $@"
307 308
}

J
Junio C Hamano 已提交
309
test_failure_ () {
310
	test_failure=$(($test_failure + 1))
311
	say_color error "not ok $test_count - $1"
312
	shift
313
	echo "$@" | sed -e 's/^/#	/'
314
	test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
J
Junio C Hamano 已提交
315 316
}

J
Junio C Hamano 已提交
317 318
test_known_broken_ok_ () {
	test_fixed=$(($test_fixed+1))
319
	say_color error "ok $test_count - $@ # TODO known breakage vanished"
J
Junio C Hamano 已提交
320 321 322 323
}

test_known_broken_failure_ () {
	test_broken=$(($test_broken+1))
324
	say_color warn "not ok $test_count - $@ # TODO known breakage"
J
Junio C Hamano 已提交
325
}
J
Junio C Hamano 已提交
326 327

test_debug () {
328
	test "$debug" = "" || eval "$1"
329 330
}

331 332 333 334 335 336 337 338 339 340 341 342 343 344
match_pattern_list () {
	arg="$1"
	shift
	test -z "$*" && return 1
	for pattern_
	do
		case "$arg" in
		$pattern_)
			return 0
		esac
	done
	return 1
}

345 346 347
test_eval_ () {
	# This is a separate function because some tests use
	# "return" to end a test_expect_success block early.
J
Jeff King 已提交
348
	eval </dev/null >&3 2>&4 "$*"
349 350
}

351
test_run_ () {
352
	test_cleanup=:
353
	expecting_failure=$2
354
	setup_malloc_check
355
	test_eval_ "$1"
356
	eval_ret=$?
357
	teardown_malloc_check
358 359 360

	if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
	then
J
Junio C Hamano 已提交
361
		setup_malloc_check
362
		test_eval_ "$test_cleanup"
J
Junio C Hamano 已提交
363
		teardown_malloc_check
364
	fi
365 366
	if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
	then
367 368
		echo ""
	fi
369
	return "$eval_ret"
370 371
}

372
test_start_ () {
373
	test_count=$(($test_count+1))
374 375 376 377 378 379 380
}

test_finish_ () {
	echo >&3 ""
}

test_skip () {
381
	to_skip=
382 383 384 385
	if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
	then
		to_skip=t
	fi
386 387
	if test -z "$to_skip" && test -n "$test_prereq" &&
	   ! test_have_prereq "$test_prereq"
388 389 390
	then
		to_skip=t
	fi
391 392
	case "$to_skip" in
	t)
393
		of_prereq=
394
		if test "$missing_prereq" != "$test_prereq"
395
		then
396
			of_prereq=" of $test_prereq"
397 398
		fi

399
		say_color skip >&3 "skipping test: $@"
400
		say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
401 402 403 404 405 406 407 408
		: true
		;;
	*)
		false
		;;
	esac
}

409 410 411 412 413
# stub; perf-lib overrides it
test_at_end_hook_ () {
	:
}

414
test_done () {
415
	GIT_EXIT_OK=t
416

417 418
	# Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
	# output file
419 420
	if test -z "$HARNESS_ACTIVE"
	then
421
		test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
422
		mkdir -p "$test_results_dir"
423 424
		base=${0##*/}
		test_results_path="$test_results_dir/${base%.sh}-$$.counts"
425

426 427 428 429 430 431 432 433
		cat >>"$test_results_path" <<-EOF
		total $test_count
		success $test_success
		fixed $test_fixed
		broken $test_broken
		failed $test_failure

		EOF
434
	fi
J
Junio C Hamano 已提交
435 436 437

	if test "$test_fixed" != 0
	then
438
		say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
J
Junio C Hamano 已提交
439 440 441
	fi
	if test "$test_broken" != 0
	then
442
		say_color warn "# still have $test_broken known breakage(s)"
443 444 445 446 447
	fi
	if test "$test_broken" != 0 || test "$test_fixed" != 0
	then
		test_remaining=$(( $test_count - $test_broken - $test_fixed ))
		msg="remaining $test_remaining test(s)"
448
	else
449
		test_remaining=$test_count
450
		msg="$test_count test(s)"
J
Junio C Hamano 已提交
451
	fi
452
	case "$test_failure" in
453
	0)
454
		# Maybe print SKIP message
455 456 457 458
		if test -n "$skip_all" && test $test_count -gt 0
		then
			error "Can't use skip_all after running some tests"
		fi
459 460
		[ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"

461 462
		if test $test_external_has_tap -eq 0
		then
463
			if test $test_remaining -gt 0
464 465 466
			then
				say_color pass "# passed all $msg"
			fi
467 468
			say "1..$test_count$skip_all"
		fi
J
Johannes Schindelin 已提交
469 470 471 472 473

		test -d "$remove_trash" &&
		cd "$(dirname "$remove_trash")" &&
		rm -rf "$(basename "$remove_trash")"

474 475
		test_at_end_hook_

476 477 478
		exit 0 ;;

	*)
479 480
		if test $test_external_has_tap -eq 0
		then
481 482 483
			say_color error "# failed $test_failure among $msg"
			say "1..$test_count"
		fi
484

485 486 487 488 489
		exit 1 ;;

	esac
}

490
if test -n "$valgrind"
491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511
then
	make_symlink () {
		test -h "$2" &&
		test "$1" = "$(readlink "$2")" || {
			# be super paranoid
			if mkdir "$2".lock
			then
				rm -f "$2" &&
				ln -s "$1" "$2" &&
				rm -r "$2".lock
			else
				while test -d "$2".lock
				do
					say "Waiting for lock on $2."
					sleep 1
				done
			fi
		}
	}

	make_valgrind_symlink () {
512 513 514 515 516 517 518
		# handle only executables, unless they are shell libraries that
		# need to be in the exec-path.  We will just use "#!" as a
		# guess for a shell-script, since we have no idea what the user
		# may have configured as the shell path.
		test -x "$1" ||
		test "#!" = "$(head -c 2 <"$1")" ||
		return;
519 520

		base=$(basename "$1")
521
		symlink_target=$GIT_BUILD_DIR/$base
522 523 524 525 526 527 528
		# do not override scripts
		if test -x "$symlink_target" &&
		    test ! -d "$symlink_target" &&
		    test "#!" != "$(head -c 2 < "$symlink_target")"
		then
			symlink_target=../valgrind.sh
		fi
529 530 531 532
		case "$base" in
		*.sh|*.perl)
			symlink_target=../unprocessed-script
		esac
533 534 535 536 537 538 539
		# create the link, or replace it if it is out of date
		make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
	}

	# override all git executables in TEST_DIRECTORY/..
	GIT_VALGRIND=$TEST_DIRECTORY/valgrind
	mkdir -p "$GIT_VALGRIND"/bin
540
	for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
541 542 543
	do
		make_valgrind_symlink $file
	done
544 545
	# special-case the mergetools loadables
	make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
546 547 548 549 550 551 552 553 554 555 556
	OLDIFS=$IFS
	IFS=:
	for path in $PATH
	do
		ls "$path"/git-* 2> /dev/null |
		while read file
		do
			make_valgrind_symlink "$file"
		done
	done
	IFS=$OLDIFS
557 558 559
	PATH=$GIT_VALGRIND/bin:$PATH
	GIT_EXEC_PATH=$GIT_VALGRIND/bin
	export GIT_VALGRIND
560 561
	GIT_VALGRIND_MODE="$valgrind"
	export GIT_VALGRIND_MODE
562 563
elif test -n "$GIT_TEST_INSTALLED"
then
564 565
	GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
	error "Cannot run git from $GIT_TEST_INSTALLED."
566
	PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
567 568
	GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
else # normal case, use ../bin-wrappers only unless $with_dashes:
569
	git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
570 571 572 573
	if ! test -x "$git_bin_dir/git"
	then
		if test -z "$with_dashes"
		then
574 575 576 577 578
			say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
		fi
		with_dashes=t
	fi
	PATH="$git_bin_dir:$PATH"
579
	GIT_EXEC_PATH=$GIT_BUILD_DIR
580 581
	if test -n "$with_dashes"
	then
582
		PATH="$GIT_BUILD_DIR:$PATH"
583
	fi
584
fi
585
GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
J
Jeff King 已提交
586 587
unset GIT_CONFIG
GIT_CONFIG_NOSYSTEM=1
588
GIT_ATTR_NOSYSTEM=1
589
export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
590

591 592 593 594 595 596 597 598 599 600
if test -z "$GIT_TEST_CMP"
then
	if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
	then
		GIT_TEST_CMP="$DIFF -c"
	else
		GIT_TEST_CMP="$DIFF -u"
	fi
fi

601
GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
602
export GITPERLLIB
603
test -d "$GIT_BUILD_DIR"/templates/blt || {
604 605
	error "You haven't built things yet, have you?"
}
606

J
Jeff King 已提交
607
if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
608
then
609
	GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
610
	export GITPYTHONLIB
611
	test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
612 613 614 615
		error "You haven't built git_remote_helpers yet, have you?"
	}
fi

616 617
if ! test -x "$GIT_BUILD_DIR"/test-chmtime
then
E
Eric Wong 已提交
618 619 620 621 622
	echo >&2 'You need to build test-chmtime:'
	echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
	exit 1
fi

623
# Test repository
J
Jeff King 已提交
624 625 626 627 628
TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
case "$TRASH_DIRECTORY" in
/*) ;; # absolute path is good
 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
629
esac
630
test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
631
rm -fr "$TRASH_DIRECTORY" || {
632
	GIT_EXIT_OK=t
633 634 635 636
	echo >&5 "FATAL: Cannot prepare test area"
	exit 1
}

637 638 639
HOME="$TRASH_DIRECTORY"
export HOME

640 641
if test -z "$TEST_NO_CREATE_REPO"
then
642
	test_create_repo "$TRASH_DIRECTORY"
643
else
644
	mkdir -p "$TRASH_DIRECTORY"
645
fi
646 647
# Use -P to resolve symlinks in our working directory so that the cwd
# in subprocesses like git equals our $PWD (for pathname comparisons).
648
cd -P "$TRASH_DIRECTORY" || exit 1
649

650 651
this_test=${0##*/}
this_test=${this_test%%-*}
652 653 654 655 656 657
if match_pattern_list "$this_test" $GIT_SKIP_TESTS
then
	say_color info >&3 "skipping test $this_test altogether"
	skip_all="skip all tests in $this_test"
	test_done
fi
658

659 660 661 662 663 664 665 666 667 668 669 670 671 672 673
# Provide an implementation of the 'yes' utility
yes () {
	if test $# = 0
	then
		y=y
	else
		y="$*"
	fi

	while echo "$y"
	do
		:
	done
}

674 675 676 677 678 679 680 681 682 683
# Fix some commands on Windows
case $(uname -s) in
*MINGW*)
	# Windows has its own (incompatible) sort and find
	sort () {
		/usr/bin/sort "$@"
	}
	find () {
		/usr/bin/find "$@"
	}
684 685 686
	sum () {
		md5sum "$@"
	}
687 688 689 690
	# git sees Windows-style pwd
	pwd () {
		builtin pwd -W
	}
691
	# no POSIX permissions
692
	# backslashes in pathspec are converted to '/'
693
	# exec does not inherit the PID
694
	test_set_prereq MINGW
695
	test_set_prereq NOT_CYGWIN
696 697 698 699 700 701
	test_set_prereq SED_STRIPS_CR
	;;
*CYGWIN*)
	test_set_prereq POSIXPERM
	test_set_prereq EXECKEEPSPID
	test_set_prereq NOT_MINGW
702
	test_set_prereq CYGWIN
703
	test_set_prereq SED_STRIPS_CR
704 705 706
	;;
*)
	test_set_prereq POSIXPERM
707
	test_set_prereq BSLASHPSPEC
708
	test_set_prereq EXECKEEPSPID
P
Pat Thoyts 已提交
709
	test_set_prereq NOT_MINGW
710
	test_set_prereq NOT_CYGWIN
711 712
	;;
esac
713

714
( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
715
test -z "$NO_PERL" && test_set_prereq PERL
716
test -z "$NO_PYTHON" && test_set_prereq PYTHON
M
Michał Kiedrowicz 已提交
717
test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
718
test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
719

720
# Can we rely on git's output in the C locale?
721 722 723 724
if test -n "$GETTEXT_POISON"
then
	GIT_GETTEXT_POISON=YesPlease
	export GIT_GETTEXT_POISON
725
	test_set_prereq GETTEXT_POISON
726 727 728
else
	test_set_prereq C_LOCALE_OUTPUT
fi
729

730 731 732 733 734 735 736 737
# Use this instead of test_cmp to compare files that contain expected and
# actual output from git commands that can be translated.  When running
# under GETTEXT_POISON this pretends that the command produced expected
# results.
test_i18ncmp () {
	test -n "$GETTEXT_POISON" || test_cmp "$@"
}

738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755
# Use this instead of "grep expected-string actual" to see if the
# output from a git command that can be translated either contains an
# expected string, or does not contain an unwanted one.  When running
# under GETTEXT_POISON this pretends that the command produced expected
# results.
test_i18ngrep () {
	if test -n "$GETTEXT_POISON"
	then
	    : # pretend success
	elif test "x!" = "x$1"
	then
		shift
		! grep "$@"
	else
		grep "$@"
	fi
}

756 757 758 759 760
test_lazy_prereq PIPE '
	# test whether the filesystem supports FIFOs
	rm -f testfifo && mkfifo testfifo
'

761 762 763 764
test_lazy_prereq SYMLINKS '
	# test whether the filesystem supports symbolic links
	ln -s x y && test -h y
'
765

766 767 768 769 770 771
test_lazy_prereq CASE_INSENSITIVE_FS '
	echo good >CamelCase &&
	echo bad >camelcase &&
	test "$(cat CamelCase)" != good
'

772 773 774 775 776 777 778 779 780 781 782 783 784
test_lazy_prereq UTF8_NFD_TO_NFC '
	# check whether FS converts nfd unicode to nfc
	auml=$(printf "\303\244")
	aumlcdiar=$(printf "\141\314\210")
	>"$auml" &&
	case "$(echo *)" in
	"$aumlcdiar")
		true ;;
	*)
		false ;;
	esac
'

785 786 787 788 789 790
test_lazy_prereq AUTOIDENT '
	sane_unset GIT_AUTHOR_NAME &&
	sane_unset GIT_AUTHOR_EMAIL &&
	git var GIT_AUTHOR_IDENT
'

791 792 793
# When the tests are run as root, permission tests will report that
# things are writable when they shouldn't be.
test -w / || test_set_prereq SANITY
794 795 796 797 798 799

GIT_UNZIP=${GIT_UNZIP:-unzip}
test_lazy_prereq UNZIP '
	"$GIT_UNZIP" -v
	test $? -ne 127
'